Index: ruby/trunk/lib/models/tests/rm/test_common.rb
===================================================================
--- ruby/trunk/lib/models/tests/rm/test_common.rb	(revision 165)
+++ ruby/trunk/lib/models/tests/rm/test_common.rb	(revision 268)
@@ -88,5 +88,5 @@
     @dv_text = OpenEHR::RM::Data_Types::Text::DV_Text.new('Test')
     @uid_based_id = OpenEHR::RM::Support::Identification::UID_Based_ID.new('rrip::0.0.5')
-    @archetype_id = OpenEHR::RM::Support::Identification::Archetype_ID.new("0.0.5", "biochemistry result_cholesterol", "entry", "ehr_rm", "openehr","cholesterol","0.0.3")
+    @archetype_id = OpenEHR::RM::Support::Identification::Archetype_ID.new('openEHR-EHR-SECTION.physical_examination-prenatal.v2')
     @template_id = OpenEHR::RM::Support::Identification::Template_ID.new('1.0.1')
     assert_nothing_raised(Exception){@archetyped = OpenEHR::RM::Common::Archetyped::Archetyped.new(@archetype_id, '1.0.1')}
@@ -144,5 +144,5 @@
     assert_nothing_raised(Exception){@archetyped.template_id = @template_id}
     assert_equal @template_id, @archetyped.template_id
-    archetype_id2 = OpenEHR::RM::Support::Identification::Archetype_ID.new("1.0.2", "biochemistry result_cholesterol", "entry", "ehr_rm", "openehr","cholesterol","0.0.3")
+    archetype_id2 = OpenEHR::RM::Support::Identification::Archetype_ID.new('openEHR-EHR-SECTION.physical_examination-prenatal.v2')
     assert_nothing_raised(ArgumentError){@archetyped.archetype_id = archetype_id2}
     assert_equal archetype_id2, @archetyped.archetype_id
Index: ruby/trunk/lib/models/tests/rm/test_data_structure.rb
===================================================================
--- ruby/trunk/lib/models/tests/rm/test_data_structure.rb	(revision 165)
+++ ruby/trunk/lib/models/tests/rm/test_data_structure.rb	(revision 268)
@@ -4,5 +4,4 @@
 
 include OpenEHR::RM::Data_Structures
-include OpenEHR::RM::Data_Structures::Item_Structure
 
 class RmDataStructureTest < Test::Unit::TestCase
@@ -25,12 +24,2 @@
   end
 end
-
-class RmDataStructureItemStructureTest < Test::Unit::TestCase
-  def setup
-    assert_nothing_raised(Exception){
-      
-  end
-
-  def test_init
-  end
-end
Index: ruby/trunk/lib/models/tests/rm/test_support.rb
===================================================================
--- ruby/trunk/lib/models/tests/rm/test_support.rb	(revision 165)
+++ ruby/trunk/lib/models/tests/rm/test_support.rb	(revision 268)
@@ -15,5 +15,5 @@
     assert_nothing_raised(Exception){@object_id = OpenEHR::RM::Support::Identification::Object_ID.new("0.0.3")}
     assert_nothing_raised(Exception){@object_ref = OpenEHR::RM::Support::Identification::Object_Ref.new('local', 'ANY', @object_id)}
-    assert_nothing_raised(Exception){@archetype_id = OpenEHR::RM::Support::Identification::Archetype_ID.new("0.0.5", "biochemistry result_cholesterol", "entry", "ehr_rm", "openehr","cholesterol","0.0.3")}
+    assert_nothing_raised(Exception){@archetype_id = OpenEHR::RM::Support::Identification::Archetype_ID.new('openEHR-EHR-SECTION.physical_examination-prenatal.v2')}
     assert_nothing_raised(Exception){@terminology_id = OpenEHR::RM::Support::Identification::Terminology_ID.new('ICD10(2003)')}
     assert_nothing_raised(Exception){@generic_id = OpenEHR::RM::Support::Identification::Generic_ID.new("0.0.3", "openehr")}
@@ -85,60 +85,12 @@
 
   def test_archetype_id
-    assert_equal "0.0.5", @archetype_id.value
-    assert_nothing_raised(Exception){@archetype_id.value = "0.0.6"}
-    assert_equal "0.0.6", @archetype_id.value
-    assert_raise(ArgumentError){@archetype_id.value=nil}
-    assert_raise(ArgumentError){@archetype_id.value=""}
-    assert_raise(ArgumentError){@archetype_id = OpenEHR::RM::Support::Identification::Archetype_ID.new}
-    assert_raise(ArgumentError){@archetype_id = OpenEHR::RM::Support::Identification::Archetype_ID.new(nil, "biochemistry result_cholesterol", "entry", "ehr_rm", "openehr","cholesterol","0.0.3")}
-    assert_raise(ArgumentError){@object_id = OpenEHR::RM::Support::Identification::Archetype_ID.new("", "biochemistry result_cholesterol", "entry", "ehr_rm", "openehr","cholesterol","0.0.3")}
-    assert_raise(ArgumentError){@archetype_id = OpenEHR::RM::Support::Identification::Archetype_ID.new("0.0.5", nil, "entry", "ehr_rm", "openehr","cholesterol","0.0.3")}
-    assert_raise(ArgumentError){@archetype_id = OpenEHR::RM::Support::Identification::Archetype_ID.new("0.0.5", "", "entry", "ehr_rm", "openehr","cholesterol","0.0.3")}
-    assert_raise(ArgumentError){@archetype_id = OpenEHR::RM::Support::Identification::Archetype_ID.new("0.0.5", "biochemistry result_cholesterol", nil, "ehr_rm", "openehr","cholesterol","0.0.3")}
-    assert_raise(ArgumentError){@archetype_id = OpenEHR::RM::Support::Identification::Archetype_ID.new("0.0.5", "biochemistry result_cholesterol", "", "ehr_rm", "openehr","cholesterol","0.0.3")}
-    assert_raise(ArgumentError){@archetype_id = OpenEHR::RM::Support::Identification::Archetype_ID.new("0.0.5", "biochemistry result_cholesterol", "entry", nil, "openehr","cholesterol","0.0.3")}
-    assert_raise(ArgumentError){@archetype_id = OpenEHR::RM::Support::Identification::Archetype_ID.new("0.0.5", "biochemistry result_cholesterol", "entry", "", "openehr","cholesterol","0.0.3")}
-    assert_raise(ArgumentError){@archetype_id = OpenEHR::RM::Support::Identification::Archetype_ID.new("0.0.5", "biochemistry result_cholesterol", "entry", "ehr_rm", nil,"cholesterol","0.0.3")}
-    assert_raise(ArgumentError){@archetype_id = OpenEHR::RM::Support::Identification::Archetype_ID.new("0.0.5", "biochemistry result_cholesterol", "entry", "ehr_rm", "","cholesterol","0.0.3")}
-    assert_raise(ArgumentError){@archetype_id = OpenEHR::RM::Support::Identification::Archetype_ID.new("0.0.5", "biochemistry result_cholesterol", "entry", "ehr_rm", "openehr",nil ,"0.0.3")}
-    assert_raise(ArgumentError){@archetype_id = OpenEHR::RM::Support::Identification::Archetype_ID.new("0.0.5", "biochemistry result_cholesterol", "entry", "ehr_rm", "openehr","","0.0.3")}
-    assert_raise(ArgumentError){@archetype_id = OpenEHR::RM::Support::Identification::Archetype_ID.new("0.0.5", "biochemistry result_cholesterol", "entry", "ehr_rm", "openehr","cholesterol", nil)}
-    assert_raise(ArgumentError){@archetype_id = OpenEHR::RM::Support::Identification::Archetype_ID.new("0.0.5", "biochemistry result_cholesterol", "entry", "ehr_rm", "openehr","cholesterol","")}
-
-    assert_equal "biochemistry result_cholesterol", @archetype_id.domain_concept
-    assert_nothing_raised(Exception){(@archetype_id.domain_concept = "biochemistry result_triglyceride")}
-    assert_equal "biochemistry result_triglyceride", @archetype_id.domain_concept
-    assert_raise(ArgumentError){@archetype_id.domain_concept = nil}
-    assert_raise(ArgumentError){@archetype_id.domain_concept = ""}
-
-    assert_equal "entry", @archetype_id.rm_name
-    assert_nothing_raised(Exception){@archetype_id.rm_name = "section"}
-    assert_equal "section", @archetype_id.rm_name
-    assert_raise(ArgumentError){@archetype_id.rm_name = nil}
-    assert_raise(ArgumentError){@archetype_id.rm_name = ""}
-
-    assert_equal "ehr_rm", @archetype_id.rm_entity
-    assert_nothing_raised(Exception){@archetype_id.rm_entity = "13606"}
-    assert_equal "13606", @archetype_id.rm_entity
-    assert_raise(ArgumentError){@archetype_id.rm_entity = nil}
-    assert_raise(ArgumentError){@archetype_id.rm_entity = ""}
-
-    assert_equal "openehr", @archetype_id.rm_originator
-    assert_nothing_raised(Exception){@archetype_id.rm_originator = "cen"}
-    assert_equal "cen", @archetype_id.rm_originator
-    assert_raise(ArgumentError){@archetype_id.rm_originator = nil}
-    assert_raise(ArgumentError){@archetype_id.rm_originator = ""}
-
-    assert_equal "cholesterol", @archetype_id.specialisation
-    assert_nothing_raised(Exception){@archetype_id.specialisation = "triglyceride"}
-    assert_equal "triglyceride", @archetype_id.specialisation
-    assert_raise(ArgumentError){@archetype_id.specialisation = nil}
-    assert_raise(ArgumentError){@archetype_id.specialisation = ""}
-
-    assert_equal "0.0.3", @archetype_id.version_id
-    assert_nothing_raised(Exception){@archetype_id.version_id = "0.0.7"}
-    assert_equal "0.0.7", @archetype_id.version_id
-    assert_raise(ArgumentError){@archetype_id.version_id = nil}
-    assert_raise(ArgumentError){@archetype_id.version_id = ""}
+    assert_equal 'openEHR-EHR-SECTION.physical_examination-prenatal.v2', @archetype_id.value
+    assert_equal 'openEHR-EHR-SECTION', @archetype_id.qualified_rm_entity
+    assert_equal 'openEHR', @archetype_id.rm_originator
+    assert_equal 'EHR', @archetype_id.rm_name
+    assert_equal 'SECTION', @archetype_id.rm_entity
+    assert_equal 'physical_examination', @archetype_id.concept_name
+    assert_equal 'prenatal', @archetype_id.specialisation
+    assert_equal 'v2', @archetype_id.version_id
   end
 